export function applyPropertyDecorators(obj, propertyKeys, propertyDecorator) {
    return new Proxy(obj, {
        get(target, propertyKey, receiver) {
            const value = Reflect.get(target, propertyKey, receiver);
            if (propertyKeys.includes(propertyKey)) {
                return propertyDecorator(value);
            }
            else {
                return value;
            }
        }
    });
}
//# sourceMappingURL=decorator.js.map